"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorFloatEditToolbar = exports.HtmlEditorFloatEditToolbarContent = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var html_float_highlight_toolbar_1 = require("./html-float-highlight-toolbar");
var uuid_1 = require("primeobjects-helper-util/build/cjs/uuid");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var html_editor_edit_tooltip_1 = __importDefault(require("./html-editor-edit-tooltip"));
var lodash_1 = require("lodash");
var HtmlEditorFloatEditToolbarContent = function (props) {
    var editor = props.editor, hideH1 = props.hideH1, hideH2 = props.hideH2, hideH3 = props.hideH3, hideH4 = props.hideH4, supportSourceCode = props.supportSourceCode, supportTooltips = props.supportTooltips;
    var primaryColor = (0, primeobjects_helper_ui_1.usePrimaryColor)();
    var hasTooltip = editor.isActive("link") && editor.getAttributes("link").href.indexOf("tooltip-") >= 0;
    var onChangeHeader = function (level) {
        editor.chain().focus().toggleHeading({ level: level }).run();
    };
    var onClickLink = function () {
        var hasLink = editor.isActive("link");
        if (hasLink) {
            editor.chain().focus().toggleLink().run();
        }
        else {
            var url = window.prompt("URL", editor.getAttributes("link").href);
            if (!(0, primeobjects_helper_util_1.isNonEmptyString)(url))
                return;
            editor.chain().focus().extendMarkRange("link").setLink({ href: url }).run();
        }
    };
    var onClickTooltip = function () {
        if (editor.isActive("link") && !hasTooltip) {
            alert("Tooltip can not be applied to a web link.");
            return;
        }
        if (editor.isActive("link")) {
            props.onClickEditTooltip && props.onClickEditTooltip(editor.getAttributes("link").href);
        }
        else {
            var id = (0, uuid_1.newGuid)();
            editor
                .chain()
                .focus()
                .extendMarkRange("link")
                .setLink({ href: "tooltip-".concat(id) })
                .run();
            props.onClickEditTooltip && props.onClickEditTooltip(id);
        }
    };
    var onRemoveTextForTooltip = function () {
        editor.chain().focus().toggleLink().run();
    };
    return (<div className="menu items-center">
            {!hideH1 && (<div onClick={function () { return onChangeHeader(1); }} className={"menu-text ".concat(editor.isActive("heading", { level: 1 }) ? "active" : "")}>
                    H1
                </div>)}
            {!hideH2 && (<div onClick={function () { return onChangeHeader(2); }} className={"menu-text ".concat(editor.isActive("heading", { level: 2 }) ? "active" : "")}>
                    H2
                </div>)}
            {!hideH3 && (<div onClick={function () { return onChangeHeader(3); }} className={"menu-text ".concat(editor.isActive("heading", { level: 3 }) ? "active" : "")}>
                    H3
                </div>)}
            {!hideH4 && (<div onClick={function () { return onChangeHeader(4); }} className={"menu-text ".concat(editor.isActive("heading", { level: 4 }) ? "active" : "")}>
                    H4
                </div>)}
            <div className="menu-sp"/>
            <div onClick={function () { return editor.chain().focus().toggleBold().run(); }} className={"menu-text menu-text-bold ".concat(editor.isActive("bold") ? "active" : "")}>
                B
            </div>
            <div onClick={function () { return editor.chain().focus().toggleItalic().run(); }} className={"menu-text menu-text-italic ".concat(editor.isActive("italic") ? "active" : "")}>
                I
            </div>
            <div onClick={function () { return editor.chain().focus().toggleStrike().run(); }} className={"menu-text menu-text-strikethrough ".concat(editor.isActive("strike") ? "active" : "")}>
                T
            </div>
            <div className="menu-sp"/>
            <primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/material-bullet-list.svg" onClick={function () { return editor.chain().focus().toggleBulletList().run(); }} className={"menu-icon"} color={editor.isActive("bulletList") ? primaryColor["600"] : primeobjects_helper_util_1.COLORS.GRAY["900"]}/>
            <primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/material-numbered-list.svg" onClick={function () { return editor.chain().focus().toggleOrderedList().run(); }} className={"menu-icon"} color={editor.isActive("orderedList") ? primaryColor["600"] : primeobjects_helper_util_1.COLORS.GRAY["900"]}/>
            <div className="menu-sp"/>
            {supportSourceCode && (<primeobjects_ui_web_basic_1.SVG src="/icons/source-code.svg" onClick={function () { return editor.chain().focus().toggleCodeBlock().run(); }} className={"menu-icon ".concat(editor.isActive("codeBlock") ? "active" : "")}/>)}
            <primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/material-get-quote.svg" onClick={function () { return editor.chain().focus().toggleBlockquote().run(); }} className={"menu-icon ".concat(editor.isActive("blockquote") ? "active" : "")}/>
            {!hasTooltip && (<primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/material-link.svg" onClick={onClickLink} className={"menu-icon"} color={editor.isActive("link") ? primaryColor["600"] : primeobjects_helper_util_1.COLORS.GRAY["900"]}/>)}

            {supportTooltips && <primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/tooltip-on.svg" onClick={onClickTooltip} className={"menu-icon"} color={hasTooltip ? primaryColor["600"] : primeobjects_helper_util_1.COLORS.GRAY["900"]}/>}

            {hasTooltip && supportTooltips && (<primeobjects_ui_web_basic_1.Tooltip title="Clicking this button will detach the selected text from tooltip" color={primeobjects_helper_util_1.COLORS.RED["600"]} textColor={primeobjects_helper_util_1.COLORS.WHITE}>
                    <primeobjects_ui_web_basic_1.SVG src="/icons/platform/html-editor/tooltip-off.svg" className={"menu-icon"} color={primeobjects_helper_util_1.COLORS.RED["600"]} onClick={onRemoveTextForTooltip}/>
                </primeobjects_ui_web_basic_1.Tooltip>)}
        </div>);
};
exports.HtmlEditorFloatEditToolbarContent = HtmlEditorFloatEditToolbarContent;
var HtmlEditorFloatEditToolbar = function (props) {
    var editor = props.editor, hideH1 = props.hideH1, hideH2 = props.hideH2, hideH3 = props.hideH3, hideH4 = props.hideH4, supportSourceCode = props.supportSourceCode, customButtons = props.customButtons, onHighlight = props.onHighlight, colors = props.colors, supportHighlight = props.supportHighlight, supportTooltips = props.supportTooltips;
    var _a = (0, react_1.useState)(undefined), editTooltipId = _a[0], setEditTooltipId = _a[1];
    var _b = (0, react_1.useState)({}), tooltips = _b[0], setTooltips = _b[1];
    (0, react_1.useEffect)(function () {
        setTooltips(props.tooltips ? props.tooltips : {});
    }, [props.tooltips]);
    var propsHtmlEditorFloatEditToolbarContent = { editor: editor, hideH1: hideH1, hideH2: hideH2, hideH3: hideH3, hideH4: hideH4, supportSourceCode: supportSourceCode };
    var propsHtmlEditorFloatHighlightToolbarContent = { editor: editor, customButtons: customButtons, onHighlight: onHighlight, colors: colors };
    var onClickEditTooltip = function (id) {
        setEditTooltipId(id.replace("tooltip-", ""));
    };
    var onUpdateTooltip = function (content) {
        var newTooltips = (0, lodash_1.cloneDeep)(tooltips);
        if ((0, primeobjects_helper_util_1.isNonEmptyString)(content)) {
            if (editTooltipId)
                newTooltips[editTooltipId] = content;
        }
        else {
            if (editTooltipId)
                delete newTooltips[editTooltipId];
        }
        setTooltips(newTooltips);
        props.onUpdateTooltips && props.onUpdateTooltips(newTooltips);
    };
    return (<react_2.BubbleMenu editor={props.editor} className="menu-wrapper editor-toolbar drop-shadow-lg">
            <div className="w-full flex flex-col">
                {<exports.HtmlEditorFloatEditToolbarContent {...propsHtmlEditorFloatEditToolbarContent} supportTooltips={supportTooltips} onClickEditTooltip={onClickEditTooltip}/>}
                {supportHighlight == true && <div className="border-t"></div>}
                {supportHighlight == true && (<div className="py-1">
                        <html_float_highlight_toolbar_1.HtmlEditorFloatHighlightToolbarContent {...propsHtmlEditorFloatHighlightToolbarContent}/>
                    </div>)}
            </div>
            <html_editor_edit_tooltip_1.default tooltipEditorProps={props.tooltipEditorProps} content={editTooltipId && tooltips[editTooltipId] ? editTooltipId && tooltips[editTooltipId] : ""} show={!(0, lodash_1.isNil)(editTooltipId)} onClose={function () {
            setEditTooltipId(undefined);
        }} onUpdate={onUpdateTooltip}/>
        </react_2.BubbleMenu>);
};
exports.HtmlEditorFloatEditToolbar = HtmlEditorFloatEditToolbar;
exports.default = exports.HtmlEditorFloatEditToolbar;
//# sourceMappingURL=html-float-edit-toolbar.jsx.map